[PATCH] fiter-branch: fix commit map init from state branch

Grant Moyer <[email protected]> Fri, 31 Jul 2026 23:31:27 -0400
Newsgroups org.kernel.vger.git
Message-ID <[email protected]>
The commit map dir is populated from the state branch assuming a
"to_commit:from_commit" format, but the state branch is written with a
"from_commit:to_commit" format, resulting in an inverted mapping when the
map is populated from the state branch. This is especially evident when
--prune-empty is used and creates commits which map to nothing; when the
map dir is populated from this state on subsequent runs, git-filter-branch
outputs many errors while trying to create files with empty names, like:

> /usr/lib/git-core/git-filter-branch: line 305: ../map/: Is a directory

This change corrects the population of the commit map dir to match the
"from_commit:to_commit" format.

Signed-off-by: Grant Moyer <[email protected]>
---
 git-filter-branch.sh     | 4 +++-
 t/t7003-filter-branch.sh | 2 +-
 2 files changed, 4 insertions(+), 2 deletions(-)

diff --git a/git-filter-branch.sh b/git-filter-branch.sh
index 24fa317aaa..9aa07be6e1 100755
--- a/git-filter-branch.sh
+++ b/git-filter-branch.sh
@@ -302,7 +302,9 @@ then
 		do
 			case "$line" in
 			*:*)
-				echo "${line%:*}" >../map/"${line#*:}";;
+				from_commit=${line%:*}
+				to_commit=${line#*:}
+				echo "$to_commit" >../map/"$from_commit";;
 			*)
 				die "Unable to load state from $state_branch:filter.map";;
 			esac
diff --git a/t/t7003-filter-branch.sh b/t/t7003-filter-branch.sh
index 86011e7b1f..3934cc4a11 100755
--- a/t/t7003-filter-branch.sh
+++ b/t/t7003-filter-branch.sh
@@ -121,7 +121,7 @@ W=$(git rev-parse HEAD)
 test_expect_success 'using --state-branch to skip already rewritten commits' '
 	test_when_finished git reset --hard $V &&
 	git reset --hard $V &&
-	git filter-branch --state-branch state -f --tree-filter "touch file || :" HEAD &&
+	git filter-branch --state-branch state -f --tree-filter "exit 1" HEAD &&
 	test_cmp_rev $W HEAD
 '
 

base-commit: a97fcc37c2bc6340a8d7ce78dedf227aac4e9aa7
-- 
2.55.0